
 
package gnu.kawa.servlet;
   
import gnu.expr.Compilation;
import gnu.mapping.CallContext;
import gnu.mapping.InPort;
import gnu.text.SourceMessages;
import gnu.xml.XMLPrinter;
import gnu.xquery.lang.XQuery;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringReader;
import java.io.Writer;
import java.util.Enumeration;

import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kawa.lang.CompileFile;


/**
 * The Xql servlet POST interpreter
 *
 * This servlet is responsible for running the POSTed XQL script
 * using the QEXO GNU library.
 * 
 * 
 * @author Ivelin Ivanov
 * 
 */
public class XqlPostServlet extends XqlServlet {

    
    public void apply(CallContext callContext)
      {
        try
          {
          ServletCallContext ctx = (ServletCallContext) callContext;
          
          log("XqlPostEngine --> ");
          log("\t     ServletPath: " +
                                    ctx.request.getServletPath());
          log("\t        PathInfo: " +
                                    ctx.request.getPathInfo());
          log("\t      RequestURI: " +
                                    ctx.request.getRequestURI());
          log("\t     QueryString: " +
                                    ctx.request.getQueryString());
          log("\t  Request Params: ");
          
          Enumeration e = ctx.request.getParameterNames();
          while (e.hasMoreElements()) 
            {
            String name = (String) e.nextElement();
            log("\t\t " + name + " = " + ctx.request.getParameter(name));
            } 
          String xqlScript = ctx.request.getParameter("xquery");
          runXql(ctx, new StringReader( xqlScript ));
          }
        catch (ServletException e)
          {
          log("Xql Interpreter Exception, because of ", e);
          }
        catch(IOException e) 
          { 
          log("Xql Interpreter Exception, because of ", e);
          }         
        catch(Throwable e) 
          { 
          log("Xql Interpreter Exception, because of ", e);
          }         
      }
 

    /**
     * POST is handled the same way as GET
     */
    public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException    
      {
        doGet(request, response);
      }


    public void destroy() 
    {
      super.destroy();
    }


}
